;This program compares a number in variable 'n' with a number set by variable 'border'
;-if n<border, print 'small', else if n<border2 print 'large', otherwise print 'huge'
;-demonstrates:
;- simple arithmetic
;- decision making using JL instruction
;- use of INT 21 to write string
;-proper arranging of the instructions can make smaller program
;- note use of 'word ptr' to inform assembler to work on a word rather than byte
;- note the layout preference of original author
;
;Original author: Ian Harries <ih@doc.ic.ac.uk>

        .MODEL SMALL  		; Data and code fit in one 64K segment
        .STACK       		; allocate a stack
		.CODE				; start of code segment

;       INT 21 - WRITE STRING TO STANDARD OUTPUT
;       AH = 09h
;       DS:DX -> '$'-terminated string
;       Return: AL = 24h (the '$' terminating the string)

border1  equ 1000			;threshold for comparison (large)
border2 equ 10000			;**threshold for comparison (huge)

		;***** setup DS register *****
        mov ax,@data		;point DS to data segment
        mov ds,ax

		;***** compare the two number and make decision *****
        cmp word ptr [n],border1 ; if n < 1000
        jl small         	;     then print("small")
        
		cmp word ptr [n],border2 ; else if n <= 10000
        jle large        	;      then print("large")
							;      else print("huge")
huge:   lea dx,mesg3		;DX=effective address (offset) of mesg3
        jmp doit

large:  lea dx,mesg2		;DX=effective address (offset) of mesg2
        jmp doit

small:  lea dx,mesg1		;DX=effective address (offset) of mesg1

doit:   mov ah,09h			;**NOTE: we direct message printout at one place, hence
        int 21h				;    minimise duplication in the source code

        mov ax,4c00h
        int 21h				; return control to DOS with errorlevel 0

        .DATA

n       dw 9999         	; int n = 9999
mesg1   db 'small$'
mesg2   db 'large$'
mesg3   db 'huge$'

        end
