;       SQUARE.TXT - draw a square with asterisks
;
;       Ian Harries <ih@doc.ic.ac.uk> 5-Nov-97

        .model small     ; Data and code fit in one 64K segment
        .stack          ; allocate a stack
        .code           ; start of code segment

;       INT 21 - READ CHARACTER FROM STANDARD INPUT, WITH ECHO
;       AH = 01h
;       Return: AL = character read

;       INT 21 - WRITE CHARACTER TO STANDARD OUTPUT
;       AH = 02h
;       DL = character to write
;       Return: AL = last character output

;       INT 21 - WRITE STRING TO STANDARD OUTPUT
;       AH = 09h
;       DS:DX -> '$'-terminated string
;       Return: AL = 24h (the '$' terminating the string)

bell    equ  7          ; ASCII
LF      equ 10          ; Control
CR      equ 13          ; Characters

star    equ '*'         ; That nice Mr Isaacson allows us to use either
zero    equ "0"         ; single- or double- quotes, but it is better
space   equ ' '         ; to stick to just one, for consistency.

MIN     equ  3
MAX     equ  9

		mov ax,@data	;initialise data segment
		mov ds,ax

getit:  mov ah,09h
        lea dx,prompt
        int 21h         ; prompt for input

        mov ah,01h
        int 21h         ; read(n)
        sub al,zero     ; ASCII char '0'-'9' -> number 0-9
        mov [n],al      ; store it for later

        mov ah,02h
        mov dl,CR
        int 21h         ; return to start
        mov dl,LF
        int 21h         ; of next line

        cmp [n],MIN     ; if n < MIN
        jl error        ; then report error
        cmp [n],MAX     ; else if n > MAX
        jg error        ;      then report error
        jmp okay        ;      else carry on

error:  mov ah,02h
        mov dl,bell
        int 21h         ; complain about invalid input
        jmp getit       ; and try again

okay:   mov cl,[n]      ; outer = n
        mov ah,02h      ; only need to do this ONCE
l0:     mov ch,[n]      ; inner = n
l1:     mov dl,star
        int 21h         ; print("*")
        mov dl,space
        int 21h         ; print(' ')
        dec ch          ; inner = inner - 1
        jne l1          ; if inner <> 0 then do it again
        mov dl,CR       ; else end of line
        int 21h
        mov dl,LF
        int 21h
        dec cl          ; outer = outer - 1
        jne l0          ; if outer <> 0 then do it again
              
        mov ax,4c00h
        int 21h		; return control to DOS with errorlevel 0

        .data

n       db ?            ; uninitialised short n
prompt  db 'type a number from 1 to 9: $'

        end
