;This program draws a vertical line with character 'star' with lenght defined by variable 'n'
;-demonstrates:
;- decision making using JG instruction
;- use of INT 21 to write character
;- note the layout preference of original author
;
;Original author: Ian Harries <ih@doc.ic.ac.uk>

        .MODEL small  	; data in 1 segment, code in 1 segment
        .STACK       	; allocate a stack

		.CODE			; start of code segment

;       INT 21 - WRITE CHARACTER TO STANDARD OUTPUT
;       AH = 02h
;       DL = character to write
;       Return: AL = last character output

star    equ '*'
CR      equ 0dh
LF      equ 0ah

        ;***** setup DS register *****
        mov ax,@data		;point DS to data segment
        mov ds,ax

	    mov cl,0        ; count = 0

l0:     inc cl          ; count = count + 1
        cmp cl,[n]      ; if count > n
        jg done         ; then done

        mov ah,02h      ; write character to standard output
        mov dl,star     ; character to write
        int 21h         ; print("*")

        mov ah,02h      ; write character to standard output
        mov dl,LF       ; character to write
        int 21h         ; print(LF) i.e. go to next line (line feed)

        mov ah,02h      ; write character to standard output
        mov dl,CR       ; character to write
        int 21h         ; print(CR) i.e. go to begin of line (carriage return)
        jmp l0          ; repeat

done:   mov ax,4c00h    ; call interrupt 21h, subroutine 4C -
        int 21h			; return control to DOS with errorlevel 0

        .data

n       db 20           ; short n = 20

        end
